<?php
	
	require_once ('functions.php');

/* Function to check, if username or email is available or not */
function query_user_check($conn, $key, $string){

	$query = "SELECT * FROM users
						WHERE $key = '{$string}' 
			 ";


	$results = mysqli_query($conn, $query);


	if ($results && mysqli_affected_rows($conn) == 1){

		$user = "{$key} Already Exists, Please choose another one";
		return $user;
	}

	return NULL;

}

/* If 'query_user_check' function return NULL then the following functions will insert a new record for the user. */
function query_insert_user($conn, $username, $pass_hash, 
							$email, $vericode, $first_name = '', $last_name = ''){

	$query = "INSERT INTO users
						VALUES (NULL, '{$username}',
								'{$pass_hash}', '{$first_name}',
								'{$last_name}', '{$email}', 
								'{$vericode}', 'Unverified', 
								0, 2, 1, 'admin'
								)
			";
	$results = mysqli_query($conn, $query);

	if($results){

		return  array ( 'username' => $username,
						'email' => $email,
						'vericode' => $vericode
					);
	}

		$status = "Can't Register Your Account at the Moment";

		return $status;
}

/* This function will set user’s status to verified once they click on the link sent to them via email. */
function query_update_user($conn, $email, $vericode){

		$query = "UPDATE users 
						SET 
							status = 'verified'
						WHERE 
							email = '{$email}' AND
							email_code = '{$vericode}'
				 ";

		
		$results = mysqli_query($conn, $query);

		if ($results && mysqli_affected_rows($conn) == 1){

			return $results;				
		}

		 else { return NULL; }
	}

/* This function will redirect users to the ‘users.php’ page if they login successfully. */
function query_login_user($conn, $username, $pass){

		$query = "SELECT * FROM users 
						WHERE username = '{$username}'	AND 
								password = '{$pass}' AND
								status = 'unverified'
				 ";


		$results = mysqli_query($conn, $query);

		if ($results && mysqli_affected_rows($conn) == 1){

			$acc_status = 	'<p> 
								You have the right credentials but you haven\'t verified your email. 
								If didn\'t get any email click on <a href="resend.php">"Resend Activation Code"</a>
							</p>
							';

			return $acc_status;
		} 

		$query = "SELECT * FROM users 
						WHERE username = '{$username}'	AND 
								password = '{$pass}' AND
								status = 'deleted'
				 ";


		$results = mysqli_query($conn, $query);

		if ($results && mysqli_affected_rows($conn) == 1){

			$acc_status = 	'<p>Your account has been blocked, 
								please contact the site administrator.
							</p>
							';

			return $acc_status;
		} 

		$query = "SELECT * FROM users 
						WHERE username = '{$username}'	AND 
								password = '{$pass}' AND
								status = 'verified' AND
								password_recover = 0
				 ";


		$results = mysqli_query($conn, $query);

		if ($results && mysqli_affected_rows($conn) == 1){
			
			$_SESSION['username'] = $username;
			
			redirect_to('user.php');			
				
		} 
		
		$query = "SELECT * FROM users 
						WHERE username = '{$username}'	AND 
								password = '{$pass}' AND
								status = 'verified' AND
								password_recover = 1

				 ";


		$results = mysqli_query($conn, $query);

		if ($results && mysqli_affected_rows($conn) == 1){
			
			$user = mysqli_fetch_assoc($results);

			$_SESSION['username'] = $user['username'];
			$_SESSION['email'] = $user['email'];
			
			redirect_to('changepass.php');			
				
		} else { return NULL; }
}

/* This function will re-send the activation code to the user's email address */
function query_resend_code($conn, $email){

	
	$query = "SELECT * FROM users 
								WHERE email = '{$email}'
				 ";

	$results = mysqli_query($conn, $query);

		if ($results && mysqli_affected_rows($conn) == 1){

			echo mysqli_affected_rows($conn) . "<br>";
			$user = mysqli_fetch_assoc($results);

			return array( 	'username' => $user['username'],
							'email' => $user['email'],
							'vericode' => $user['email_code']
						);
		} 

		return NULL;	
}


/* This function will send a password to the user and will lock all other options*/
function query_pass_request($conn, $email){

	$vericode = substr(md5($email + microtime()), 1, 10);

	$query = "UPDATE users
					SET email_code = '{$vericode}'
					WHERE email = '{$email}' 					
			";
	
	$results = mysqli_query($conn, $query);

	if ($results && mysqli_affected_rows($conn) == 1){
		
		return array( 	'email' => $email,
						'vericode' => $vericode
					);
		} 

	return NULL;	
}

/* This function will send a password to the user and will lock all other options*/
function query_resend_pass($conn, $email, $vericode){

	$letters = 'abcefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ1234567890';
	$random_pass = substr(str_shuffle($letters), 0, 6);
	$random_hash = secure_password($random_pass);

	$query = "UPDATE users

					SET 
							password = '{$random_hash}',
							password_recover = 1,
							status = 'Verified'
					WHERE 
							email = '{$email}' AND
							email_code = '{$vericode}' 					
			";
	
	$results = mysqli_query($conn, $query);
	echo mysqli_error($conn);

	if ($results && mysqli_affected_rows($conn) == 1){
		
		$query = "SELECT * FROM users
							WHERE email = '{$email}' AND
							email_code = '{$vericode}'
				 ";
		
		$results = mysqli_query($conn, $query);

		if ($results && mysqli_affected_rows($conn) == 1){

			$user = mysqli_fetch_assoc($results);

			return array( 	'username' => $user['username'],
							'email' => $user['email'],
							'password' => $random_pass
							);
		}
	} 

	return NULL;	
}


/* This function will send a password to the user and will lock all other options*/
function query_update_pass($conn, $username, $password, $email){

	$query = "UPDATE users

					SET password = '{$password}',
						password_recover = 0

				WHERE 	email = '{$email}' AND
						username = '{$username}'
			";

	$results = mysqli_query($conn, $query);
	echo mysqli_error($conn);
	if($results && mysqli_affected_rows($conn) == 1){

		$status = '	Thank You! Your Password has been changed. <br />
				  	<a href="login.php"> Click Here </a> to go back to login Page.  
				  ';
		return $status;
	}

	return NULL;	
}

function query_return_info($conn, $username){

	$query = "SELECT * FROM users
					WHERE 	username = '{$username}'
			";

	$results = mysqli_query($conn, $query);
	
	if($results && mysqli_affected_rows($conn) == 1){

		$user = mysqli_fetch_assoc($results);

		return $user;
	}

	return NULL;	
}
?>