<?php

/* Function for redirecting user to a certain location */
function redirect_to($new_location){

	header("Location: " . $new_location);
	exit();
}

/* Function for connecting to the database. */
function db_connect(){

	$host = 'localhost';
	$user = 'tanzeelniazi';
	$pass = 'abc';
	$db = 'Busarna';

	$conn = @mysqli_connect($host, $user, $pass, $db);

	if(mysqli_connect_errno()){

		die (mysqli_connect_error());
	}

	return $conn;
}

/* Function to check whether the user entered required amount of characters for the field. */	
function field_length($conn, $key, $string, $min = 5, $max = 200){

	if(strlen($string) < $min) {

		$status = "{$key} should be atleast 6 characters long.";
		return $status;
	}

	if(strlen($string) > $max) {

		$status = "{$key} must be less then 200 characters.";
		return $status;
	}

	return NULL;
}

/* Strip out any bad input typed by the user. */	
function safe_out($conn, $string){

	$string = strip_tags($string);
	$string = trim($string);
	$string = htmlspecialchars($string);
	$string = mysqli_real_escape_string($conn, $string);

	return $string;
}


/* Applying BlowFish encryption on the password */
function secure_password($password){

		$hash_format = "$2y$10$";
		$salt = md5("Tanz33lN!@zi@SpinZRphp");

		$salt_format = $hash_format . $salt;
		$hash = crypt($password, $salt_format);

		return $hash;
}	


?>