<?php 

   ob_start();
   session_start();
    
    require_once('functions.php');
    require_once ('functions.user.php');
    if (isset($_SESSION['username']))
       {redirect_to ('user.php');}

?>
<!DOCTYPE html>
<html>
<head>
    <title>Log In</title>

<?php

    if ($_SERVER['REQUEST_METHOD'] == 'POST' &&
            !empty($_POST['username']) &&
            !empty($_POST['password']) &&
            isset($_POST['login'])
        ){
            $conn = db_connect();

            $username = safe_out($conn, $_POST['username']);
            $password = safe_out($conn, $_POST['password']);
            $pass_hash = secure_password($password);

            $result = query_login_user($conn, $username, $pass_hash);

            /* If the above query was successfull user will be redirected to the 'users.php' otherwise the following code will execute. */

            if(is_null($result))
            { 
                $result = '<p>Invalid Username / Password, Try again or 
                <a href="register.php">Register</a> for a new account</p>';

            } 

        }
?>
</head>

<body>
<?php
            if(isset($result)) {

               echo $result;
            }
            
?>

    <form action="" method="POST" >
        <table>
            <tr>
                <td><label for="username">Username: </label> </td>
                <td><input type="text" name="username" id="username" /></td>
            </tr>

            <tr>
                <td><label for="password">Password: </label></td>
                <td><input type="password" name="password" id="password" /></td>
            </tr>
        </table>

            <input type="submit" value="Log In" name="login" /> 
            &nbsp;  
            <input type="button" value="Register" onClick="location.href='register.php'" /> <br />
            <input type="button" value="Forgot Password" onClick="location.href='forgot.php'" />
    </form>
    
</body>
<?php 
        if (isset($conn)){

            mysqli_close($conn); 

          }

?>
</html>
